//-------------------------------------------------------------
//  SheriffOnline.com - Free MQL Code Service
//-------------------------------------------------------------
// Keywords: MT4, create EA, expert advisor developer

#property copyright "Copyright  2013, SheriffOnline.com - Free MQL Code Service"
#property link      "http://www.sheriffonline.com/"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern int HoursFrom3 = 1;
extern int HoursTo3 = 23;
extern double BuyLots30 = 0.1;
extern int BuyStoploss30 = 20;
extern int BuyTakeprofit30 = 10;
extern double SellLots32 = 0.1;
extern int SellStoploss32 = 20;
extern int SellTakeprofit32 = 10;
extern int TrailingStop25 = 10;
extern int NewTakeProfit25 = 10;
extern int TrailingGap25 = 7;


// local variables
double PipValue=1;    
bool Terminated = false;
string LF = "\n";  
int NDigits = 4;   
int ObjCount = 0;  
int current = 0;

bool FirstTime7 = true;
bool FirstTime24 = true;
int Count31 = 0;


int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick1();
    
}

void OnEveryTick1()
{
    if (true == false && false) PipValue = 10;
    if (true && (NDigits == 3 || NDigits == 5)) PipValue = 10;
    
    WeekdayFilter2();
    PrintInfoToChart31();
    TrailingStop25();
    
}

void WeekdayFilter2()
{
    if ((true && DayOfWeek() == 1) || (true && DayOfWeek() == 2) || (true && DayOfWeek() == 3) ||
    (true && DayOfWeek() == 4) || (true && DayOfWeek() == 5) || (true && DayOfWeek() == 6) || (true && DayOfWeek() == 0))
    {
        HoursFilter3();
        
    }
}

void HoursFilter3()
{
    int datetime800 = TimeLocal();
    int hour0 = TimeHour(datetime800);
    
    if ((HoursFrom3 < HoursTo3 && hour0 >= HoursFrom3 && hour0 < HoursTo3) ||
    (HoursFrom3 > HoursTo3 && (hour0 < HoursTo3 || hour0 >= HoursFrom3)))
    {
        TechnicalAnalysis2x4();
        TechnicalAnalysis2x26();
        
    }
}

void TechnicalAnalysis2x4()
{
    if ((iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,2) > 0) && (iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,1) > 0))
    {
        TechnicalAnalysis2x27();
        
    }
}

void TechnicalAnalysis2x27()
{
    if ((iRSI(NULL, NULL,3,PRICE_CLOSE,0) < 90) && (iRSI(NULL, NULL,8,PRICE_CLOSE,0) > 50))
    {
        TechnicalAnalysis5();
        
    }
}

void TechnicalAnalysis5()
{
    if (iADX(NULL, NULL,12,PRICE_CLOSE,MODE_PLUSDI,0) > iADX(NULL, NULL,12,PRICE_CLOSE,MODE_MINUSDI,0))
    {
        IfOrderDoesNotExist6();
        
    }
}

void IfOrderDoesNotExist6()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        CheckLastOrderType7();
        
    }
}

void CheckLastOrderType7()
{
    int orderType = -1;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            orderType = OrderType();
        }
    }
    if (orderType == OP_SELL || FirstTime7)
    {
        FirstTime7 = false;
        BuyOrder30();
        
    }
}

void BuyOrder30()
{
    double SL = Ask - BuyStoploss30*PipValue*Point;
    if (BuyStoploss30 == 0) SL = 0;
    double TP = Ask + BuyTakeprofit30*PipValue*Point;
    if (BuyTakeprofit30 == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots30, Ask, 4, 0, 0, "SheriffOnline.com - Free MQL Code Service", 1, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots30, Ask, 4, SL, TP, "SheriffOnline.com - Free MQL Code Service", 1, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TechnicalAnalysis2x26()
{
    if ((iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,2) < 0) && (iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,1) < 0))
    {
        TechnicalAnalysis2x28();
        
    }
}

void TechnicalAnalysis2x28()
{
    if ((iRSI(NULL, NULL,3,PRICE_CLOSE,0) > 10) && (iRSI(NULL, NULL,8,PRICE_CLOSE,0) < 50))
    {
        TechnicalAnalysis29();
        
    }
}

void TechnicalAnalysis29()
{
    if (iADX(NULL, NULL,12,PRICE_CLOSE,MODE_MINUSDI,0) > iADX(NULL, NULL,12,PRICE_CLOSE,MODE_PLUSDI,0))
    {
        IfOrderDoesNotExist8();
        
    }
}

void IfOrderDoesNotExist8()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        CheckLastOrderType24();
        
    }
}

void CheckLastOrderType24()
{
    int orderType = -1;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            orderType = OrderType();
        }
    }
    if (orderType == OP_BUY || FirstTime24)
    {
        FirstTime24 = false;
        SellOrder32();
        
    }
}

void SellOrder32()
{
    double SL = Bid + SellStoploss32*PipValue*Point;
    if (SellStoploss32 == 0) SL = 0;
    double TP = Bid - SellTakeprofit32*PipValue*Point;
    if (SellTakeprofit32 == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, SellLots32, Bid, 4, 0, 0, "SheriffOnline.com - Free MQL Code Service", 1, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, SellLots32, Bid, 4, SL, TP, "SheriffOnline.com - Free MQL Code Service", 1, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void PrintInfoToChart31()
{
    string temp = "SheriffOnline.com - Free MQL Code Service\nExecuted : " + Count31 + "\n"
    + "Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD)/PipValue, 2)+ "\n"
    + "------------------------------------------------\n"
    + "ACCOUNT INFORMATION:\n"
    + "\n"
    + "Account Name:     " + AccountName()+ "\n"
    + "Account Leverage:     " + DoubleToStr(AccountLeverage(), 0)+ "\n"
    + "Account Balance:     " + DoubleToStr(AccountBalance(), 2)+ "\n"
    + "Account Equity:     " + DoubleToStr(AccountEquity(), 2)+ "\n"
    + "Free Margin:     " + DoubleToStr(AccountFreeMargin(), 2)+ "\n"
    + "Used Margin:     " + DoubleToStr(AccountMargin(), 2)+ "\n"
    + "------------------------------------------------\n";
    Comment(temp);
    Count31++;
    
}

void TrailingStop25()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            double takeprofit = OrderTakeProfit();
            
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop25*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop25+TrailingGap25)*PipValue*Point)
                {
                    if (NewTakeProfit25 != 0) takeprofit = Ask+(NewTakeProfit25 + TrailingStop25)*PipValue*Point;
                    bool ret1 = OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop25*PipValue*Point, takeprofit, OrderExpiration(), White);
                    if (ret1 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop25*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop25+TrailingGap25)*PipValue*Point)
                {
                    if (NewTakeProfit25 != 0) takeprofit = Bid-(NewTakeProfit25 + TrailingStop25)*PipValue*Point;
                    bool ret2 = OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop25*PipValue*Point, takeprofit, OrderExpiration(), White);
                    if (ret2 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}



int deinit()
{
    if (false) ObjectsDeleteAll();
    
    
}


